/*************************************************************************
 *
 *  $RCSfile: uidldisp.hxx,v $
 *
 *  $Revision: 1.2 $
 *
 *  last change: $Author: np $ $Date: 2002/05/14 09:02:10 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef ADC_UIDLDISP_HXX
#define ADC_UIDLDISP_HXX



// USED SERVICES
	// BASE CLASSES
	// COMPONENTS
	// PARAMETERS

namespace ary
{
namespace info
{
class CodeInformation;
}   // namespace info
}   // namespace ary

namespace ary
{
namespace uidl
{
class CeNamespace;
}   // namespace uidl
}   // namespace ary


namespace display
{
class CorporateFrame;
}

namespace csi
{
namespace uidl
{

class Module;
class Service;
class Interface;
class Struct;
class Exception;
class Enum;
class Typedef;
class ConstantsGroup;

class Constant;
class Property;
class Function;
class Attribute;
class StructElement;
class EnumValue;


using ary::info::CodeInformation;



class Display
{
  public:
	virtual				~Display() {}

	virtual void		WriteGlobalIndices() = 0;

	virtual void	 	InitModule(
							const char *		i_sModule,
							const char *		i_sPath,
							uintt				i_nDepth ) = 0;

	virtual void	  	Display_Module(
							const ary::uidl::CeNamespace &
												i_rData,
							const CodeInformation *
												i_rDocu ) = 0;
	virtual void	  	Display_Service(
							const Service &		i_rData,
							const CodeInformation *
												i_rDocu ) = 0;
	virtual void	  	Display_Interface(
							const Interface & 	i_rData,
							const CodeInformation *
												i_rDocu ) = 0;
	virtual void	  	Display_Struct(
							const Struct &		i_rData,
							const CodeInformation *
												i_rDocu ) = 0;
	virtual void	  	Display_Exception(
							const Exception &	i_rData,
							const CodeInformation *
												i_rDocu ) = 0;
	virtual void	  	Display_Enum(
							const Enum &		i_rData,
							const CodeInformation *
												i_rDocu ) = 0;
	virtual void	  	Display_Typedef(
							const Typedef &		i_rData,
							const CodeInformation *
												i_rDocu ) = 0;
	virtual void	  	Display_ConstantsGroup(
							const ConstantsGroup &
												i_rData,
							const CodeInformation *
												i_rDocu ) = 0;
	virtual void	  	Display_Constant(
							const Constant & 	i_rData,
							const CodeInformation *
												i_rDocu ) = 0;
	virtual void	  	Display_Property(
							const Property & 	i_rData,
							const CodeInformation *
												i_rDocu ) = 0;
	virtual void	  	Display_Function(
							const Function &	i_rData,
							const CodeInformation *
												i_rDocu ) = 0;
	virtual void	  	Display_Attribute(
							const Attribute &	i_rData,
							const CodeInformation *
												i_rDocu ) = 0;
	virtual void	  	Display_StructElement(
							const StructElement &
												i_rData,
							const CodeInformation *
												i_rDocu  ) = 0;
	virtual void	  	Display_EnumValue(
							const EnumValue &	i_rData,
							const CodeInformation *
												i_rDocu  ) = 0;
};

DYN Display *		Create_HtmlDisplay_(
						const udmstri &		i_sOutputDirectory,
						const display::CorporateFrame &
											i_rFrame );
}   // namespace uidl
}   // namespace csi

#endif

