/*************************************************************************
 *
 *  $RCSfile: heapmanager.hxx,v $
 *
 *  $Revision: 1.3 $
 *
 *  last change: $Author: jb $ $Date: 2002/03/15 13:50:51 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef CONFIGMGR_DATAHEAPMANAGER_HXX
#define CONFIGMGR_DATAHEAPMANAGER_HXX

#ifndef CONFIGMGR_DATALOCK_HXX
#include "datalock.hxx"
#endif

#ifndef _SAL_TYPES_H_
#include <sal/types.h>
#endif
#ifndef _RTL_STRING_HXX_
#include <rtl/string.hxx>
#endif

namespace configmgr
{
// -----------------------------------------------------------------------------	
    namespace memory
    {
    // -------------------------------------------------------------------------
        class HeapManager
        {
        public:
            typedef struct Opaque_ * Handle;

            typedef sal_uInt32      Size;
            typedef sal_uInt32      Address;
            typedef rtl::OString    HeapId;
            typedef rtl::OString const & HeapIdParam;

        //    virtual HeapId newHeapId() = 0;
            virtual Handle createHeap(/*HeapIdParam _anId, */Size _sInitialSize) = 0;
            virtual Handle attachHeap(HeapIdParam _anId, Size & _rInitialSize) = 0;
            virtual Size   growHeap(Handle _aHeap, Size _sNewSize) = 0;
            virtual void   destroyHeap(Handle _aHeap) = 0;

            virtual void *  base(Handle _aHeap) = 0;
            virtual HeapId  id(Handle _aHeap) = 0;

            virtual Address allocate(Handle _aHeap, Size _sNewSize) = 0;
            virtual Address reallocate(Handle _aHeap, Address _aOldAddress, Size _sNewSize) = 0;
            virtual void    deallocate(Handle _aHeap, Address _aAddress) = 0;
            virtual bool    didAllocate(Handle _aHeap, Address _aAddress) = 0;

            typedef DataLock Lock;

            virtual Lock *  createHeapLock(Handle _aHeap) = 0;
            virtual void    destroyHeapLock(Handle _aHeap, Lock * _pLock) = 0;
        };
    // -------------------------------------------------------------------------
    }
// -----------------------------------------------------------------------------	
} // namespace configmgr

#endif // CONFIGMGR_DATAHEAPMANAGER_HXX

