#*************************************************************************
#
#   $RCSfile: makefile.mk,v $
#
#   $Revision: 1.7 $
#
#   last change: $Author: hr $ $Date: 2003/03/25 13:52:42 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2002 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************
PRJ=..$/..

PRJNAME=desktop
TARGET=pkgchk
TARGETTYPE=CUI
USE_DEFFILE=TRUE
ENABLE_EXCEPTIONS=TRUE
NO_BSYMBOLIC=TRUE

# --- Settings -----------------------------------------------------

.INCLUDE :  svpre.mk
.INCLUDE :  settings.mk
.INCLUDE :  sv.mk

# --- pkgchk shared library ---

SLOFILES= \
	$(SLO)$/pkgchk_misc.obj					\
	$(SLO)$/pkgchk_unorc.obj				\
	$(SLO)$/pkgchk_packages.obj				\
	$(SLO)$/pkgchk_configuration.obj			\
	$(SLO)$/pkgchk_basic.obj				\
	$(SLO)$/pkgchk_classpath.obj				\
	$(SLO)$/pkgchk_log.obj					\
	$(SLO)$/pkgchk_env.obj					\
	$(SLO)$/pkgchk_mgr.obj

SHL1TARGET=$(TARGET)$(UPD)$(DLLPOSTFIX)

SHL1STDLIBS= \
	$(SALLIB)						\
	$(CPPULIB)						\
	$(CPPUHELPERLIB)					\
	$(UNOTOOLSLIB)						\
	$(UCBHELPERLIB)						\
	$(XMLSCRIPTLIB)

SHL1DEPN=
SHL1IMPLIB=i$(TARGET)
SHL1LIBS=$(SLB)$/$(TARGET).lib
SHL1DEF=$(MISC)$/$(SHL1TARGET).def

DEF1NAME=$(SHL1TARGET)
DEF1DEPN=$(MISC)$/$(SHL1TARGET).flt $(SHL1LIBS)

DEFLIB1NAME=$(TARGET)

# --- pkgchk executable ---

CXXFILES= \
	pkgchk_app.cxx

APP1TARGET=$(TARGET)

APP1OBJS= \
	$(OBJ)$/pkgchk_app.obj

APP1STDLIBS= \
	$(SALLIB)						\
	$(CPPULIB)						\
	$(PKGCHKLIB)

APP1DEPN=$(SHL1TARGETN)

# --- misc ---

.IF "$(debug)" != ""

# msvc++: disable inlining for debugging purposes
.IF "$(COM)" == "MSC"
CFLAGS += -Ob0
.ENDIF

.ENDIF

# some diagnose
.IF "$(diag)" != ""
CFLAGS += -DDIAG=$(diag)
.ENDIF

.INCLUDE :  target.mk

.IF "$(depend)" == ""

# --- Filter-Datei ---

$(MISC)$/$(SHL1TARGET).flt: makefile.mk
	@echo ------------------------------
	@echo CLEAR_THE_FILE				> $@
	@echo _TI					>> $@
	@echo _real					>> $@
        @echo pkgchk_env				>> $@
        @echo STL					>> $@
        @echo stl					>> $@
        @echo Reference					>> $@
        @echo Sequence					>> $@
        @echo Type					>> $@
        @echo xmlscript					>> $@

.ENDIF

