/*************************************************************************
 *
 *  $RCSfile: prvwshll.hxx,v $
 *
 *  $Revision: 1.1 $
 *
 *  last change: $Author: thb $ $Date: 2001/08/07 13:36:07 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _SD_PRVWSHLL_HXX
#define _SD_PRVWSHLL_HXX

#include "drviewsh.hxx"

/**
   The class SdPreviewViewShell provides a convenient way to preview the
   first page of a Draw/Impress document. No user interaction is possible, 
   although a living document is displayed. The view is inherited from 
   the SdDrawViewShell.
 */

class SdPreviewViewShell : public SdDrawViewShell
{
public:		
	TYPEINFO();
    
	SFX_DECL_VIEWFACTORY( SdPreviewViewShell );
	SFX_DECL_INTERFACE( SD_IF_SDPREVIEWVIEWSHELL );
    
	SdPreviewViewShell(SfxViewFrame* pFrame, const SdDrawViewShell& rShell);
	SdPreviewViewShell(SfxViewFrame* pFrame, SfxViewShell* pOldShell);
	~SdPreviewViewShell();

	// ensure usage of full window for preview
	virtual void InnerResizePixel(const Point &rPos, const Size &rSize);
	virtual void OuterResizePixel(const Point &rPos, const Size &rSize);
	virtual void AdjustPosSizePixel(const Point &rPos, const Size &rSize);

	// own functions for user input to prevent interaction
	virtual BOOL KeyInput(const KeyEvent& rKEvt, SdWindow* pWin);
	virtual void MouseMove(const MouseEvent& rMEvt, SdWindow* pWin);
	virtual void MouseButtonUp(const MouseEvent& rMEvt, SdWindow* pWin);
	virtual void MouseButtonDown(const MouseEvent& rMEvt, SdWindow* pWin);

	// prevent display of rulers 
	virtual SvxRuler* CreateHRuler(SdWindow* pWin, BOOL bIsFirst);
	virtual SvxRuler* CreateVRuler(SdWindow* pWin);
};

#endif // _SD_PRVWSHLL_HXX
