/*************************************************************************
 *
 *  $RCSfile: pipath.hxx,v $
 *
 *  $Revision: 1.11 $
 *
 *  last change: $Author: hr $ $Date: 2003/03/27 11:08:57 $
 *
 *  The Contents of this file are made available subject to the terms of
 *  either of the following licenses
 *
 *         - GNU Lesser General Public License Version 2.1
 *         - Sun Industry Standards Source License Version 1.1
 *
 *  Sun Microsystems Inc., October, 2000
 *
 *  GNU Lesser General Public License Version 2.1
 *  =============================================
 *  Copyright 2000 by Sun Microsystems, Inc.
 *  901 San Antonio Road, Palo Alto, CA 94303, USA
 *
 *  This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser General Public
 *  License version 2.1, as published by the Free Software Foundation.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA  02111-1307  USA
 *
 *
 *  Sun Industry Standards Source License Version 1.1
 *  =================================================
 *  The contents of this file are subject to the Sun Industry Standards
 *  Source License Version 1.1 (the "License"); You may not use this file
 *  except in compliance with the License. You may obtain a copy of the
 *  License at http://www.openoffice.org/license.html.
 *
 *  Software provided under this License is provided on an "AS IS" basis,
 *  WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
 *  WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
 *  MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
 *  See the License for the specific provisions governing your rights and
 *  obligations concerning the Software.
 *
 *  The Initial Developer of the Original Code is: Sun Microsystems, Inc.
 *
 *  Copyright: 2000 by Sun Microsystems, Inc.
 *
 *  All Rights Reserved.
 *
 *  Contributor(s): _______________________________________
 *
 *
 ************************************************************************/

#ifndef _PIPATH_HXX
#define _PIPATH_HXX

#ifndef _AGENTPG_HXX
#include "agentpg.hxx"
#endif

#ifndef _SV_FIXED_HXX
#include <vcl/fixed.hxx>
#endif

#ifndef _SV_EDIT_HXX //autogen
#include <vcl/edit.hxx>
#endif

#ifndef _SVTABBX_HXX //autogen
#include <svtools/svtabbx.hxx>
#endif

#ifndef _LIST_HXX //autogen
#include <tools/list.hxx>
#endif

#include "highcontrasthelper.hxx"

class SiEnvironment;

struct HD_Entry {
	USHORT	nVol;
	ULONG	nFree;
	ULONG	nUse;
	BOOL 	bSysVol;
};

DECLARE_LIST(SiHDEntries,HD_Entry*)

class DriveTabBox : public SvTabListBox
{
	SvLBoxButtonData*	pBtnDataProgLang;
	SvLBoxButtonData*	pBtnDataDocLang;

	OHighContrastHelper m_aHighContrastHelper;

public:
		DriveTabBox(Window* pParent, const ResId& rResId);
		~DriveTabBox();

	void 	SetTabs();
	void 	InsertDrive( BOOL bNet, const ByteString& rName, const ByteString& rNeed, const ByteString& rFree, HD_Entry* pHDEntry );

	virtual void KeyInput( const KeyEvent& rEvt );
};

class PageInstPath : public SvAgentPage
{
		FixedText		aFTInfo1;
		FixedText		aFTInfo2;
		FixedText		aFTInfo3;
		FixedText		aFTInfo4;
		FixedText		aFTInfo5;

		FixedText       m_aAdabasInfo;

		Edit			aEDPath;
		PushButton		aBtnBrowse;
		DriveTabBox		aDriveBox;

		Edit			aEDResponsefile;

		String 			aVolume;
		String 			aFree;
		String 			aNeed;

		HeaderBar*		pHeaderBar;
		SiEnvironment*	pEnv;
		ULONG 			m_lClusterSize;
		ULONG 			m_lUsedSize;
		ULONG 			m_lClusterSizeSystem;
		ULONG			m_lSystemSize;
		ULONG			m_lTempSize;

		SiHDEntries		m_aHDEntries;

		void			CorrectToFirstFree(BOOL bScanRemoveableDisks =FALSE);
		void			RecalcSize(const SiDirEntry& rDest);
		void 			UpdateDriveBox();


	OHighContrastHelper m_aHighContrastHelper;
	virtual void DataChanged( DataChangedEvent const & _rDCEvt );

        // #91456# free size
        bool isEnoughSpace( const SiDirEntry& _aPath );
        UniString createPathName();

		DECL_LINK(BrowseHdl, Button*);
 		DECL_LINK(DblClickHdl, void*);

	BOOL isAdabas();
public:
		PageInstPath( SvAgentDlg* pParent, const ResId& rResId );
		~PageInstPath();

	static SvAgentPage*		Create(SvAgentDlg* pParent, const ResId& rResId);

	virtual BOOL			AllowNext();
	virtual ULONG			GetProperty();
	virtual void			InitProperty(ULONG nProp);
};

#endif //_PIPATH_HXX

