#*************************************************************************
#
#   $RCSfile: static.mk,v $
#
#   $Revision: 1.26.46.1 $
#
#   last change: $Author: vg $ $Date: 2004/01/28 10:54:08 $
#
#   The Contents of this file are made available subject to the terms of
#   either of the following licenses
#
#          - GNU Lesser General Public License Version 2.1
#          - Sun Industry Standards Source License Version 1.1
#
#   Sun Microsystems Inc., October, 2000
#
#   GNU Lesser General Public License Version 2.1
#   =============================================
#   Copyright 2000 by Sun Microsystems, Inc.
#   901 San Antonio Road, Palo Alto, CA 94303, USA
#
#   This library is free software; you can redistribute it and/or
#   modify it under the terms of the GNU Lesser General Public
#   License version 2.1, as published by the Free Software Foundation.
#
#   This library is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
#   Lesser General Public License for more details.
#
#   You should have received a copy of the GNU Lesser General Public
#   License along with this library; if not, write to the Free Software
#   Foundation, Inc., 59 Temple Place, Suite 330, Boston,
#   MA  02111-1307  USA
#
#
#   Sun Industry Standards Source License Version 1.1
#   =================================================
#   The contents of this file are subject to the Sun Industry Standards
#   Source License Version 1.1 (the "License"); You may not use this file
#   except in compliance with the License. You may obtain a copy of the
#   License at http://www.openoffice.org/license.html.
#
#   Software provided under this License is provided on an "AS IS" basis,
#   WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING,
#   WITHOUT LIMITATION, WARRANTIES THAT THE SOFTWARE IS FREE OF DEFECTS,
#   MERCHANTABLE, FIT FOR A PARTICULAR PURPOSE, OR NON-INFRINGING.
#   See the License for the specific provisions governing your rights and
#   obligations concerning the Software.
#
#   The Initial Developer of the Original Code is: Sun Microsystems, Inc.
#
#   Copyright: 2000 by Sun Microsystems, Inc.
#
#   All Rights Reserved.
#
#   Contributor(s): _______________________________________
#
#
#
#*************************************************************************

.IF "$(OFFICEUPD)"==""
STATICUPD=$(UPD)
.ELSE
STATICUPD=$(OFFICEUPD)
.ENDIF 

.IF "$(GUI)"=="WNT"
# -----------------------------------------------------------
# --------------------- Windows32 ---------------------------
# -----------------------------------------------------------
#.IF "$(STATICUPD)" >= 640 
#SALLIBST  		=	$(SALLIB)
#.ELSE
SALLIBST  		=	asal.lib
#.ENDIF
BOOTSTRP		=	bootstrp.lib
TRANSEX			=	transex.lib
VERMAP			= 	bsvermap.lib
STATIC_LIBS		=	advapi32.lib						\
					user32.lib							\
					shell32.lib 						\
					mpr.lib 							\
					ole32.lib							\
					uuid.lib 							\
					wsock32.lib							\
					$(L)$/avos.lib
.IF "$(PRJNAME)" == "tools"
STATIC_LIBS		+= 	$(LB)$/atools.lib
.ELSE
STATIC_LIBS		+= 	atools.lib
.ENDIF
STATIC_LIBS		+= 	uwinapi.lib	\
					ascii_expat_xmlparse.lib			\
					expat_xmltok.lib			\
					$(SALLIB)
.IF "$(LIBSTLPORT)" != ""
STATIC_LIBS		+= 	$(LIBSTLPORT)
.ENDIF
# -----------------------------------------------------------

.ELSE
.IF "$(GUI)"=="UNX"
# -----------------------------------------------------------
# ------------------------ UNIX -----------------------------
# -----------------------------------------------------------

BOOTSTRP		=	-lbtstrp
TRANSEX			=	-ltransex
VERMAP			=	-lbsvermap

STATIC_LIBS+=$(STATIC)

STATIC_LIBS		+= \
					-latools 							\
					$(LIBSTLPORTST)						\
					$(STATIC)

STATIC_LIBS		+= 	-lsal$(DLLPOSTFIX)		\
					-lascii_expat_xmlparse				\
					-lexpat_xmltok

.IF "$(COM)"=="C52"
.IF "$(BUILD_SOSL)"==""
STATIC_LIBS		+= -lCrun_static
.ELSE			# "$(BUILD_SOSL)"==""
STATIC_LIBS		+= -lCrun
.ENDIF			# "$(BUILD_SOSL)"==""
.ENDIF			# "$(COM)"=="C52"

STATIC_LIBS+=$(DYNAMIC) \
					-lvos$(VOS_MAJOR)$(COMID)

.IF "$(OS)"=="SOLARIS"
STATIC_LIBS		+= -lnsl -lsocket -lposix4 -lc
.ENDIF
.IF "$(OS)"=="LINUX"
.IF "$(CVER)"=="C295"
STATIC_LIBS		+=	-lX11 -lXext 
.ELSE
STATIC_LIBS		+=	-lsupc++ -lX11 -lXext 
.ENDIF
.ENDIF

# -----------------------------------------------------------

.ELSE
.IF "$(GUI)"=="OS2"
# -----------------------------------------------------------
# ------------------------- OS2 -----------------------------
# -----------------------------------------------------------
BOOTSTRP		=	bootstrp.lib
VERMAP			= 	bsvermap.lib
STATIC_LIBS		=	$(L)$/atools.lib					\
					$(L)$/avos.lib
STATIC_LIBS		+= 	$(L)$/asal.lib
# -----------------------------------------------------------

.ENDIF
.ENDIF
.ENDIF
